#include "Stack.h"

Stack::Stack() {
	this->sp = 0;
	// Kreiramo dinamicki niz sa StartingStackSize elemenata
	stack = new int[StartingStackSize];
	size = StartingStackSize;
}

bool Stack::push(int in) {
	// Ukoliko smo stigli do poslednje lokacije, moramo da povecamo velicinu niza
	if (this->sp == size) {
		// Ne postoji zamena za funkciju realloc u C++ pa moramo sami da izvrsimo povecanje duzine niza
		// Kreiramo nov niz cija je velicina veca od trenutnog za StackSizeIncrement elemenata
		int* tmp = new int[size + StackSizeIncrement];
		// Kopiramo sve elemente iz niza stack u niz tmp
		for (int i = 0; i < size; i++) {
			tmp[i] = stack[i];
		}
		// Izbrisemo stari niz!!!
		delete[] stack;
		// Stari niz pokazuje na novokreirani niz
		stack = tmp;
		// Azuriramo maksimalnu velicinu niza
		size += StackSizeIncrement;
	}
	stack[this->sp] = in;
	this->sp++;
	return true;
}

bool Stack::pop(int* out) {
	if (this->sp == 0) return false;
	// U slucaju da imamo previse slobodnog mesta (vise od StackSizeDecrement)
	if (size - this->sp > StackSizeDecrement) {
		// Onda smanjujemo niz tako sto kreiramo niz sa manje lokacija
		int* tmp = new int[size - StackSizeDecrement];
		// Kopiramo sve elemente iz niza stack u niz tmp
		for (int i = 0; i < this->sp; i++) {
			tmp[i] = stack[i];
		}
		// Izbrisemo stari niz!!!
		delete[] stack;
		// Stari niz pokazuje na novokreirani niz
		stack = tmp;
		// Azuriramo maksimalnu velicinu niza
		size -= StackSizeDecrement;
	}
	this->sp--;
	*out = stack[this->sp];
	return true;
}

bool Stack::isEmpty() {
	return this->sp == 0;
}

// Destruktor klase je posebna funkcija clanica klase (kao i konstruktor) koja se poziva kada brisemo objekat neke klase (pozivom operatora delete)
// Potrebna je u svim klasama sa pokazivackim poljima da bismo na ispravan nacin izbrisali ono na sta oni pokazuju
// Naime pozivom operatora delete mi brisemo samo taj konkretan objekat i sva njegova polja, medjutim ukoliko u objektu postoji pokazivac koji ukazuje na neki drugi deo memorije, taj deo memorije ce ostati neizbrisan (curenje memorije)
// Dakle potrebno je da definisemo destruktor koji brise sve iz dinamicke memorije sto je nas objekat u toku programa kreirao (u ovom slucaju, samo dinamicki niz)
Stack::~Stack() {
	delete[] this->stack;
}
