#include "Stack.h"

Stack::Stack() {
	first = nullptr;
}

bool Stack::push(int in) {
	// Metoda push dodaje nov element u listu na pocetak
	Elem* newElem = new Elem;
	newElem->info = in;
	newElem->next = first;
	// Azuriramo prvi element liste
	first = newElem;
	return true;
}

bool Stack::pop(int* out) {
	// Ako ne postoji lista vracamo false
	if (first == nullptr) return false;
	// U suprotnom citamo broj na pocetku liste i brisemo prvi element liste
	*out = first->info;
	Elem* tmp = first;
	first = first->next;
	delete tmp;
	return true;
}

bool Stack::isEmpty() {
	// Lista je prazna ako ne postoji prvi element liste
	return first == nullptr;
}

// Destruktor klase je posebna funkcija clanica klase (kao i konstruktor) koja se poziva kada brisemo objekat neke klase (pozivom operatora delete)
// Potrebna je u svim klasama sa pokazivackim poljima da bismo na ispravan nacin izbrisali ono na sta oni pokazuju
// Naime pozivom operatora delete mi brisemo samo taj konkretan objekat i sva njegova polja, medjutim ukoliko u objektu postoji pokazivac koji ukazuje na neki drugi deo memorije, taj deo memorije ce ostati neizbrisan (curenje memorije)
// Dakle potrebno je da definisemo destruktor koji brise sve iz dinamicke memorije sto je nas objekat u toku programa kreirao (u ovom slucaju, celu listu)
Stack::~Stack() {
	while (first != nullptr) {
		Elem* tmp = first;
		first = first->next;
		delete tmp;
	}
	first = nullptr;
}
